From 4ae6045b62da403f76ed8cbb9a28a5523d99c298 Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Fri, 22 Apr 2022 00:35:18 -0400
Subject: [PATCH v2 2/5] More cleanup to pg_lsn.c

---
 src/backend/utils/adt/pg_lsn.c | 17 +++++++++++------
 1 file changed, 11 insertions(+), 6 deletions(-)

diff --git a/src/backend/utils/adt/pg_lsn.c b/src/backend/utils/adt/pg_lsn.c
index 90ecd0e7590..e0991d4d2f6 100644
--- a/src/backend/utils/adt/pg_lsn.c
+++ b/src/backend/utils/adt/pg_lsn.c
@@ -22,6 +22,8 @@
 #define MAXPG_LSNLEN			17
 #define MAXPG_LSNCOMPONENT	8
 
+static inline XLogRecPtr numeric_to_pg_lsn(Numeric num);
+
 /*----------------------------------------------------------
  * Formatting and conversion routines.
  *---------------------------------------------------------*/
@@ -60,15 +62,18 @@ pg_lsn_in_internal(const char *str, bool *have_error)
 	return result;
 }
 
+static inline XLogRecPtr
+numeric_to_pg_lsn(Numeric num)
+{
+	return (XLogRecPtr) numeric_to_uint64_type(num, "pg_lsn");
+}
+
 Datum
 numeric_pg_lsn(PG_FUNCTION_ARGS)
 {
 	Numeric		num = PG_GETARG_NUMERIC(0);
-	XLogRecPtr	result;
-
-	result = (XLogRecPtr) numeric_to_uint64_type(num, "pg_lsn");
 
-	PG_RETURN_LSN(result);
+	PG_RETURN_LSN(numeric_to_pg_lsn(num));
 }
 
 Datum
@@ -286,7 +291,7 @@ pg_lsn_pli(PG_FUNCTION_ARGS)
 							  NumericGetDatum(nbytes));
 
 	/* Convert to pg_lsn */
-	return DirectFunctionCall1(numeric_pg_lsn, res);
+	PG_RETURN_LSN(numeric_to_pg_lsn(DatumGetNumeric(res)));
 }
 
 /*
@@ -320,5 +325,5 @@ pg_lsn_mii(PG_FUNCTION_ARGS)
 							  NumericGetDatum(nbytes));
 
 	/* Convert to pg_lsn */
-	return DirectFunctionCall1(numeric_pg_lsn, res);
+	PG_RETURN_LSN(numeric_to_pg_lsn(DatumGetNumeric(res)));
 }
-- 
2.18.0

